// filefind.h

#ifndef __FILEFIND_H__
#define __FILEFIND_H__

#if _MFC_VER <= 0x0253

////////////////////////////////////////////////////////////////////////////
// CFileFind - MSDOS CFileFind, Copyright (c) Troels K. 2002

class CFileFind : public CObject
{
public:
   CFileFind();
   virtual ~CFileFind();

// Attributes
public:
   DWORD GetLength() const;
#if defined(_X86_) || defined(_ALPHA_)
   __int64 GetLength64() const;
#endif
   virtual CString GetFileName() const;
   virtual CString GetFilePath() const;
   virtual CString GetFileTitle() const;
   virtual CString GetFileURL() const;
   virtual CString GetRoot() const;

   //virtual BOOL GetLastWriteTime(FILETIME* pTimeStamp) const;
   //virtual BOOL GetLastAccessTime(FILETIME* pTimeStamp) const;
   //virtual BOOL GetCreationTime(FILETIME* pTimeStamp) const;
   virtual BOOL GetLastWriteTime(CTime& refTime) const;
   virtual BOOL GetLastAccessTime(CTime& refTime) const;
   virtual BOOL GetCreationTime(CTime& refTime) const;

   virtual BOOL MatchesMask(DWORD dwMask) const;

   virtual BOOL IsDots() const;
   // these aren't virtual because they all use MatchesMask(), which is
   BOOL IsReadOnly() const;
   BOOL IsDirectory() const;
   BOOL IsCompressed() const;
   BOOL IsSystem() const;
   BOOL IsHidden() const;
   BOOL IsTemporary() const;
   BOOL IsNormal() const;
   BOOL IsArchived() const;

// Operations
   void Close();
   virtual BOOL FindFile(LPCTSTR pstrName = NULL, DWORD dwUnused = 0);
   virtual BOOL FindNextFile();

protected:
   virtual void CloseContext();

// Implementation
protected:
   void* m_pFoundInfo;
   void* m_pNextInfo;
   void* m_hContext;
   BOOL m_bGotLast;
   CString m_strRoot;
   TCHAR m_chDirSeparator;     // not '\\' for Internet classes

#ifdef _DEBUG
   void Dump(CDumpContext& dc) const;
   void AssertValid() const;
#endif

   DECLARE_DYNAMIC(CFileFind)
};

#define _AFX_INLINE inline

// CFileFind
_AFX_INLINE BOOL CFileFind::IsReadOnly() const
   { return MatchesMask(_A_RDONLY); }
_AFX_INLINE BOOL CFileFind::IsDirectory() const
   { return MatchesMask(_A_SUBDIR); }
_AFX_INLINE BOOL CFileFind::IsCompressed() const
   { return FALSE; }
_AFX_INLINE BOOL CFileFind::IsSystem() const
   { return MatchesMask(_A_SYSTEM); }
_AFX_INLINE BOOL CFileFind::IsHidden() const
   { return MatchesMask(_A_HIDDEN); }
_AFX_INLINE BOOL CFileFind::IsTemporary() const
   { return FALSE; }
_AFX_INLINE BOOL CFileFind::IsNormal() const
   { return MatchesMask(_A_NORMAL); }
_AFX_INLINE BOOL CFileFind::IsArchived() const
   { return MatchesMask(_A_ARCH); }
#endif // MFC_VER
#endif // __FILEFIND_H__
