#include <QtGui>
#include <QProcess>
#include "mainwindow.h"
#include "ui_mainwindow.h"

QProcess *tpfextract = new QProcess();

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::BrowseClicked()
{
    QString path;
    QTreeWidgetItem *temp;
    FILE *filelist;
    char str[512];
    QStringList parameters, info;
    double size;
    QString filesize;

    path = QFileDialog::getOpenFileName(
        this,
        "Choose a file to open",
        QString::null,
        "*.tpf");
    if (path == NULL) {
        return;
    }
    ui->treeWidgetFilelist->clear();
    parameters << "-f" << path;
    tpfextract->start("TPFextract", parameters);
    tpfextract->waitForFinished();

    filelist = fopen("filelist.txt", "r");
    while (fgets(str, 512, filelist) != NULL) {
        if (str[strlen(str) - 1] == '\n') {
                str[strlen(str) - 1] = '\0';
        }
        QString qstr(str);
        info = qstr.split("|");
        size = info.at(1).toDouble();
        if (size<1024) {
                filesize = QString::number(size, 'f', 2) + " B";
        } else if (size/1024 < 1024) {
                filesize = QString::number(size/1024, 'f', 2) + " kB";
        } else {
                filesize = QString::number(size/1024/1024, 'f', 2) + " MB";
        }

        temp = new QTreeWidgetItem( ui->treeWidgetFilelist );
        temp->setText(0, info.at(0) );
        temp->setText(1, filesize ); temp->setTextAlignment(1,Qt::AlignRight);
        temp->setText(2, info.at(2) ); temp->setTextAlignment(2,Qt::AlignRight);
    }
    fclose(filelist);
    remove("filelist.txt");

    ui->lineEditPath->setText(path);
}

void MainWindow::readFromStdout()
{
    QByteArray data = tpfextract->readAllStandardOutput();
    QString qstr(data);
    if (qstr != NULL)
        ui->lineEditPath->setText(qstr);
}

/*void MainWindow::extractStarted()
{
    //Extracting started
}*/

void MainWindow::extractEnded()
{
    ui->lineEditPath->setText("Done - Select new file");
}

void MainWindow::ExtractClicked()
{
    QStringList parameters;
    QString path, directory;
    path = ui->lineEditPath->text();
    if (path == NULL || path=="Done - Select new file") {
        return;
    }
    directory = QFileDialog::getExistingDirectory(
        this,
        "Extract to...",
        QString::null);
    if (directory == NULL) {
        return;
    }

    parameters << "-xo" << path;
    tpfextract->setWorkingDirectory(directory);
    tpfextract->setReadChannel(QProcess::StandardOutput);

    //connect (tpfextract, SIGNAL(started()), this, SLOT(extractStarted()));
    connect (tpfextract, SIGNAL(readyReadStandardOutput()), this, SLOT(readFromStdout()));
    connect (tpfextract, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(extractEnded()));

    tpfextract->start("TPFextract", parameters);

}

void MainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}
